// Pro krokový motor 28BYJ-48 s řadičem ULN2003
// ZKUŠEBNÍ VERZE 1

// čísla pinů pro digitální výstupy
const int out1 =  8;
const int out2 =  9;
const int out3 = 10;
const int out4 = 11;

const int buttonClockwise = 2;      //pin tlačítka1 směr hodin
const int buttonAntiClockwise = 3;  //pin tlačítka2 směr proti hodin
const int buttonDefault = 4;        //pin tlačítka3 najetí na výchozí polohu
const int switchRight = 5;          //pin mikrospínače najetí na výchozí polohu vpravo
const int switchLeft = 6;           //pin mikrospínače najetí na výchozí polohu vlevo
 
int rychlost = 1; // proměnná pro nastavení rychlosti,se zvětšujícím se číslem se rychlost zmenšuje

int uhel = 10;   // proměnná úhel otočení na jeden cyklus
int otocka = 0;  // proměnná počet cyklů ( délka přejezdu posuvny )

void setup() {

  pinMode(buttonClockwise, INPUT);  // pin tlačítka1 směr hodin
  pinMode(buttonAntiClockwise, INPUT); // pin tlačítka2 směr proti hodin
  pinMode(buttonDefault, INPUT); // pin tlačítka3 najetí na výchozí polohu
  pinMode(switchRight, INPUT); // pin mikrospínače najetí na výchozí polohu vpravo
  pinMode(switchLeft, INPUT); // pin mikrospínače najetí na výchozí polohu vlevo
  
  // inicializace digitálních výstupů
  pinMode(out1, OUTPUT);
  pinMode(out2, OUTPUT);
  pinMode(out3, OUTPUT);
  pinMode(out4, OUTPUT);
}

void loop()  {

  boolean Clockwise = digitalRead(buttonClockwise);
  boolean switchLeftState = digitalRead(switchLeft);

  if (Clockwise == LOW){  // motor stojí když je tlačítko1 rozpojeno
   uhel = 0;
  }
  else if (switchLeftState == LOW){ // když je levý mikrospínač rozpojen a tlačítko1 spojeno točí se motor po směru hodin
  otocka = 68; // počet cyklů
  }

  while(otocka>0){
  rotationClockwise(); // volání funkce po směru
  otocka--;
    for(int i=0;i<(uhel*64/45);i++){  // motor udělá pohyb směru hodin o nastavený úhel
    rotationClockwise();
    }
  }
 
  boolean AntiClockwise = digitalRead(buttonAntiClockwise);
  boolean switchRightState = digitalRead(switchRight);

  if ((AntiClockwise == HIGH)&&(switchRightState == LOW)){  // když je tlačítko2 spojeno a pravý mikrospínač rozpojen točí se motor protisměru hodin
  otocka = 68;  // počet cyklů
  }
  while(otocka>0){
  rotationAnticlockwise(); 
  otocka--;
  }
  
  for(int i=0;i<(uhel*64/45);i++){ // motor udělá pohyb proti směru hodin o nastavený úhel
  rotationAnticlockwise(); 
  }

  boolean defaultState = digitalRead(buttonDefault);

  if ((defaultState == HIGH)&&(switchRightState == LOW)){ // motor se točí protisměru hodin dokud je spojeno tlačítko3 a rozpojen pravý mikrospínač
  rotationAnticlockwise();
  } 
}

// zde následují funkce pro volání jednotlivých
// kroků pro otočení po či proti směru hodinových
// ručiček
void rotationAnticlockwise() { 
  krok1();
  krok2();
  krok3();
  krok4();
  krok5();
  krok6();
  krok7();
  krok8();
}
void rotationClockwise() { 
  krok8();
  krok7();
  krok6();
  krok5();
  krok4();
  krok3();
  krok2();
  krok1();
}
// každý krok obsahuje výrobcem dané pořadí
// pro správné spínání motoru a následnou
// pauzu, kterou určujeme rychlost otáčení
void krok1(){
  digitalWrite(out1, HIGH);
  digitalWrite(out2, LOW);
  digitalWrite(out3, LOW);
  digitalWrite(out4, LOW);
  delay(rychlost);
}
void krok2(){
  digitalWrite(out1, HIGH);
  digitalWrite(out2, HIGH);
  digitalWrite(out3, LOW);
  digitalWrite(out4, LOW);
  delay(rychlost);
}
void krok3(){
  digitalWrite(out1, LOW);
  digitalWrite(out2, HIGH);
  digitalWrite(out3, LOW);
  digitalWrite(out4, LOW);
  delay(rychlost);
}
void krok4(){
  digitalWrite(out1, LOW);
  digitalWrite(out2, HIGH);
  digitalWrite(out3, HIGH);
  digitalWrite(out4, LOW);
  delay(rychlost);
}
void krok5(){
  digitalWrite(out1, LOW);
  digitalWrite(out2, LOW);
  digitalWrite(out3, HIGH);
  digitalWrite(out4, LOW);
  delay(rychlost);
}
void krok6(){
  digitalWrite(out1, LOW);
  digitalWrite(out2, LOW);
  digitalWrite(out3, HIGH);
  digitalWrite(out4, HIGH);
  delay(rychlost);
}
void krok7(){
  digitalWrite(out1, LOW);
  digitalWrite(out2, LOW);
  digitalWrite(out3, LOW);
  digitalWrite(out4, HIGH);
  delay(rychlost);
}
void krok8(){
  digitalWrite(out1, HIGH);
  digitalWrite(out2, LOW);
  digitalWrite(out3, LOW);
  digitalWrite(out4, HIGH);
  delay(rychlost);
}




